<template>
  <AppAbstractPage
    :breadcrumbs="$route.params.query ? breadcrumbs : []"
    class="_pageMainSearch">
    <AppSearch
      :current="$route.params.query"
      class="_on-page"
      slot="abstractPage-search"/>

    <template v-if="$route.params.query">
      <div
        v-if="$route.params.query"
        slot="heading"
        class="pageHeading">
        <div class="pageHeading-basic">
          <h1
            v-if="isFound"
            class="heading _h1">
            По запросу &laquo;{{ $route.params.query }}&raquo; найдены следующие совпадения
          </h1>
          <h1
            v-else
            class="heading _h1">
            К сожалению, мы не нашли запчасти по вашему запросу &laquo;{{ $route.params.query }}&raquo;
          </h1>
        </div>
        <div class="pageHeading-additional">
          <ButtonsCallHelper/>
        </div>
      </div>

      <div slot="additional">
        <!-- Показывать блок когда найдены совпадения. С селектом для уточнения производителя -->
        <!-- <div
          v-if="isFound"
          class="searchAdditional">
          <AppWarning>
            <template #warning>
              <div class="paragraph">
                Запчасти разных производителей могут иметь одинаковые номера. Проверьте бренд и название детали.
              </div>
            </template>
          </AppWarning>

          <div class="searchAdditional-form __box-gray">
            <div class="form">
              <div class="form-item">
                <AppSelect
                  v-model="filtersModel.manufacturer"
                  :options="filtersValues.manufacturer"
                  :label="null"
                  :track-by="null"
                  placeholder="Производитель"/>
              </div>
              <div class="form-item">
                <div class="input">
                  <input
                    v-model="filtersModel.name"
                    type="text"
                    placeholder="Название запчасти"
                    class="input-field">
                </div>
              </div>
            </div>
          </div>
        </div> -->

        <!-- Показывать блок когда не найдено ничего. -->
        <div
          v-if="!isFound"
          class="searchAdditional">
          <AppWarning>
            <template #warning>
              <div class="paragraph">Проверьте номер, все ли цифры на месте, может, нужны и буквы.
              Проверьте раскладку клавиатуры.</div>
              <div class="paragraph">Если вы уверены, что эта деталь существует, отправьте продавцам
                <flink
                  href="/request-to-spare"
                  class="link">
                  запрос на запчасть
                </flink>
              </div>
            </template>
          </AppWarning>
        </div>
      </div>

      <div
        v-if="isFound"
        slot="content"
        class="searchSpecifying">
        <AppTable
          class="tableSpecifying"
          :table-headings="headings"
          :grid="grid">
          <!--картинка запчасти-->
          <template
            :slot="`unit-${headings[0].name}`"
            slot-scope="{ part }">
            <div class="picture">
              <img
                v-if="part.partImages && part.partImages.length"
                :src="part.partImages[0]"
                :alt="`${part.brand} ${part.vendorCode}`">
              <img
                v-else
                svg-inline
                src="~/assets/svg/redesign/navigation-parts.svg">
            </div>
          </template>

          <!--название бренда + артикул запчасти (для мобилки)-->
          <template
            :slot="`unit-${headings[1].name}`"
            slot-scope="{ part }">
            <span class="__hide-shadow __no-wrap">
              {{ part.brand }}</span><span class="valueIsMobile">, {{ part.vendorCode }}</span>
          </template>

          <!--артикул запчасти-->
          <template
            :slot="`unit-${headings[2].name}`"
            slot-scope="{ part }">
            <flink
              :href="href4Item(part)"
              class="link __hide-shadow __no-wrap">
              {{ part.vendorCode }}
            </flink>
          </template>

          <!--название запчасти-->
          <div
            :slot="`unit-${headings[3].name}`"
            slot-scope="{ part }">
            {{ part.partName }}
          </div>

          <!--список применяемости-->
          <div
            :slot="`unit-${headings[4].name}`"
            slot-scope="{ part }">
            <div class="listApplicability">
              <span class="valueIsMobile">Применяемость:</span>
              <template v-if="part.carManufacturers.length">
                {{ part.carManufacturers | join(', ') }}
                <AppButton
                  :classes="['buttonAsLink']"
                  @click.native="onClickShowApplicability(part)">
                  <template #button-item>
                    см.все
                  </template>
                </AppButton>
              </template>
              <template v-else>&ndash;</template>
            </div>
          </div>

          <!--цена - только для мобилки-->
          <div
            :slot="`unit-${headings[5].name}`"
            slot-scope="{ part }">
            <!-- <div class="sellerPrice">
              <div class="__bold">500 ₽</div>
            </div> -->
          </div>

          <!--количество предложений в выбранном городе-->
          <template
            :slot="`unit-${headings[6].name}`"
            slot-scope="{ part }">
            <flink
              v-if="part.userLocationCount"
              :href="href4Item(part)"
              class="button buttonSellerCounter">
              {{ part.userLocationCount | spacifyNumber }}
              {{ part.userLocationCount | transChoose(['предложение', 'предложения', 'предложений']) }}
            </flink>
            <div
              v-else
              class="noResult">Нет предложений</div>
          </template>

          <!--количество предложений в стране-->
          <!--этого столбца может не быть-->
          <template
            :slot="`unit-${headings[7].name}`"
            slot-scope="{ part }">
            <div class="valueIsMobile">Всего на портале</div>
            <flink
              :href="`${href4Item(part)}?location=0`"
              class="button buttonSellerCounter">
              {{ part.allOffersCount | spacifyNumber }}
              {{ part.allOffersCount | transChoose(['предложение', 'предложения', 'предложений']) }}
            </flink>
          </template>

          <template
            :slot="`unit-${headings[8].name}`"
            slot-scope="{ part }">
            <div class="__gray">
              {{ location.name || 'Все страны' }}
            </div>
          </template>
        </AppTable>

        <PartApplicability
          :show-content="{desktop: 'modal', mobile: 'modal'}"
          v-model="applicabilityModal.visible"
          :entities="applicabilityModal.list"
          :structure="$options.applicability"/>
      </div>

      <div
        v-else-if="grid.data.length"
        slot="content"
        class="pageSubheading">

        <div class="heading _h2">
          Что ищут {{ currentLocation }} прямо сейчас
        </div>

        <TopOffersTable :grid="grid" />
      </div>
    </template>
  </AppAbstractPage>
</template>

<script>
import { mapState } from 'vuex';
import { uniq } from 'lodash-es';

import { specifyingSearchRequest } from '~/assets/js/filters';
import mapFilters from '~/assets/js/helpers/map-filters';
import { applicabilityExpert as applicability } from '~/assets/js/mocks/table/headings';
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/search';

import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppSearch from '~/components/redesign/app-search/app-search';
import ButtonsCallHelper from '~/components/redesign/app-buttons/buttons-call-helper';
import AppSelect from '~/components/redesign/app-select/app-select';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppTable from '~/components/redesign/app-table/app-table';
import AppWarning from '~/components/redesign/app-warning';
import PartApplicability from '~/components/redesign/part-applicability';
import TopOffersTable from '~/components/redesign/app-table/top-offers';

export default {
  name: 'MainSearch',
  components: {
    PartApplicability,
    AppWarning,
    AppAbstractPage,
    AppTable,
    ButtonsCallHelper,
    AppSearch,
    AppSelect,
    AppButton,
    TopOffersTable,
  },
  mixins: [SeoMixin, SeoPageMixin],
  async asyncData({ app, params }) {
    if (!params.query) {
      return {
        isFound: false,
        gridData: [],
      };
    }

    try {
      let { data } = await app.$axios.$get('/_main/search/list', {
        params: {
          query: specifyingSearchRequest(params.query),
        },
      });

      const isFound = Boolean(data.length);
      if (!isFound) {
        ({ data } = await app.$axios.$get('/_main/part/getLastRequested'));
      }

      return {
        isFound,
        gridData: data,
      };
    } catch (e) {
      console.error(e);
    }
    return {
      isFound: false,
      gridData: [],
    };
  },
  data() {
    return {
      filtersModel: {
        manufacturer: null,
        name: null,
      },
      applicabilityModal: {
        visible: false,
        list: [],
      },
      breadcrumbs: [
        {
          url: '',
          name: 'Поиск',
        },
      ],
    };
  },
  computed: {
    ...mapState(['location']),
    grid() {
      return {
        data: this.gridData
          .filter(item => !this.filtersModel.manufacturer || item.brand === this.filtersModel.manufacturer)
          .filter(
            item => !this.filtersModel.name
            || item.partName.toLowerCase().includes(this.filtersModel.name.toLowerCase())
          ),
      };
    },
    filtersValues() {
      return {
        manufacturer: uniq(this.gridData.map(item => item.brand)).sort(),
      };
    },
    currentLocation() {
      return this.location.id
        ? `в ${this.location.prepositionalName}`
        : 'во всех странах';
    },
    headings() {
      return [
        {
          name: 'img',
          title: '',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'brand',
          title: 'Производитель',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'number',
          title: 'Номер',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'partName',
          title: 'Название',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'applicability',
          title: 'Применяемость',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'price',
          title: '',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'sellerCounterLocal',
          title: `Предложения в ${this.location.prepositionalName}`,
          hidden: !this.location.id,
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'sellerCounterAll',
          title: 'Всего на сайте',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'topMobile',
          title: '',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
      ];
    },
  },
  watch: {
    async 'location.id'(newValue, oldValue) {
      if (!this.$route.params.query) {
        return;
      }

      if (newValue !== oldValue) {
        try {
          let { data } = await this.$axios.$get('/_main/search/list', {
            params: {
              query: specifyingSearchRequest(this.$route.params.query),
            },
          });

          const isFound = Boolean(data.length);
          if (!isFound) {
            ({ data } = await this.$axios.$get('/_main/part/getLastRequested'));
          }

          this.isFound = isFound;
          this.gridData = data;
        } catch (e) {
          console.error(e);
        }
      }
    },
  },
  created() {
    this.$options.applicability = applicability;
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    href4Item(part) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(part.brand));
      url.push(this.vendorCodeSlug(part.vendorCode));
      return url.join('/');
    },
    async onClickShowApplicability(part) {
      try {
        const { data } = await this.$axios.$get('/_main/partInfo/getApplicability', {
          params: { id: part.partId },
        });
        this.applicabilityModal.list = data || [];
        this.applicabilityModal.visible = true;
      } catch (e) {
        console.error(e);
      }
    },
  },
};

</script>

<style lang="postcss">
  /* autoprefixer: off */
  ._pageMainSearch {
    .pageHeading {
      display: flex;
      justify-content: space-between;

      &-basic {
        display: block;
      }

      &-additional {
        display: inline-flex;
        align-items: flex-end;
        margin-top: -1rem;
      }

      .buttonsCallHelper {
        margin-left: 2rem;
      }

      @media screen and (max-width: 1200px) {
        .buttonsCallHelper {
          display: none;
        }
      }

      @media screen and (max-width: 980px) {
        flex-direction: column;

        &-additional {
          margin: 0 auto;
          width: 100%;
        }

        .buttonsCallHelper {
          margin-left: 0;
          margin-top: 1rem;
        }
      }
    }

    .pageSubheading {
      .heading {
        padding-bottom: 1.25rem;
      }

      @media screen and (max-width: 980px) {
        .heading {
          padding: 1.25rem;
        }
      }
    }

    .pageSearch {
      padding: 1rem 0 4rem 0;

      &-form {
        position: relative;
        z-index: 2;
        display: flex;
        justify-content: center;
        padding-bottom: 2.5rem;
        width: 100%;
      }

      &-title {
        display: block;
        padding-bottom: 1.5rem;
      }

      @media screen and (max-width: 980px) {
        padding: 1.25rem 0 5rem 0;
        &-form {
          padding: 0 1.25rem 1.25rem 1.25rem;
        }

        &-title {
          padding: 0 1.25rem 1.25rem 1.25rem;
        }
      }
    }

    /* Стили для блоков с инфой, когда что-то не найдено */
    .searchAdditional {
      display: block;
      width: 100%;

      &-form {
        display: flex;
        padding: 1.5rem;
        border-radius: 0;

        .form {
          display: flex;
          justify-content: flex-start;
          align-items: center;
          width: 100%;

          &-item {
            display: flex;
            flex-direction: column;
            margin-right: 1.25rem;

            &:last-child {
              margin-right: 0;
            }
          }
        }

        &._align-center {
          justify-content: center;
        }
      }

      @media screen and (min-width: 981px) {
        position: relative;
        margin-bottom: 1.5rem;

        .form {
          padding-left: 5rem;
        }

        .input {
          width: 26rem;
        }

        .multiselect {
          width: 14.5rem;
        }
      }

      @media screen and (max-width: 980px) {
        &-form {
          padding-left: 1.25rem;
          padding-right: 1.25rem;

          .form {
            flex-direction: column;
            width: 100%;

            &-item {
              margin: 0;
              width: 100%;
            }

            .form-item + .form-item {
              margin-top: 0.75rem;
            }

            .input {
              width: 100%;
              height: var(--btn-mobile-min-height);
            }

            .multiselect {
              width: 100%;
            }
          }
        }
      }
    }

    .searchSpecifying {
      display: block;
      padding-bottom: 4rem;
    }

    /* Стили для таблицы уточняющей, когда найдены собвпадения */
    .tableSpecifying {
      .th, .td {
        &._img {
          grid-area: img;
        }

        &._brand {
          grid-area: brand;
        }

        &._number {
          grid-area: number;
        }

        &._partName {
          grid-area: partName;
        }

        &._applicability {
          grid-area: applicability;
        }

        &._price {
          grid-area: price;
        }

        &._sellerCounterLocal {
          grid-area: sellerCounterLocal;
          align-items: center;
          text-align: center;
        }

        &._sellerCounterAll {
          grid-area: sellerCounterAll;
          align-items: center;
          text-align: center;
        }

        &._topMobile {
          grid-area: topMobile;
        }
      }

      @media screen and (min-width: 981px) {
        &.table {
          .tr {
            grid-template-columns:
              6.5rem 0.7fr 0.7fr 1fr 1fr 12rem 12rem;
            grid-template-areas:
              "img brand number partName applicability sellerCounterLocal sellerCounterAll";
          }

          .th._price,
          .td._price,
          .th._topMobile,
          .td._topMobile {
            display: none;
          }

          .td._img {
            padding: 0;
            border-right: 1px solid var(--border-color-main);
          }

          .td._brand,
          .td._number {
            font-weight: var(--font-weight-medium);

            .link {
              color: var(--color-main);
              &:hover {
                color: var(--link-hover-color);
              }
            }
          }

          .td._applicability {
            color: var(--color-main-lightest);

            .buttonAsLink {
              display: inline-block;
              margin-left: -1.375rem;
              width: 4rem;
              font-size: inherit;
              text-align: right;
              background-image: linear-gradient(270deg,var(--bg-main) 2.5rem, var(--bg-transparent));
            }
          }

          .td._sellerCounterLocal,
          .td._sellerCounterAll {
            justify-content: center;

            .buttonSellerCounter {
              width: 100%;
            }
          }

          .noResult {
            font-weight: var(--font-weight-medium);
          }

          .picture {
            padding-top: 5.375rem;
            background-color: var(--bg-lightest);

            > .svg {
              width: 2.5rem;
              height: auto;
              fill: var(--fill-light);
            }
          }

          .__hide-shadow {
            margin-right: -2rem;
          }

          .valueIsMobile {
            display: none;
          }

          .buttonSellerCounter {
            white-space: nowrap;
          }
        }
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        &.table {
          .tr {
            grid-template-columns:
              6.5rem 0.8fr 1fr 0.7fr 10.5rem 10.5rem;
            grid-template-areas:
              "img brand partName applicability sellerCounterLocal sellerCounterAll"
              "img number partName applicability sellerCounterLocal sellerCounterAll";
            grid-template-rows: auto 1fr;
          }

          .th._number,
          .td._number {
            padding-top: 0;
            border-top: none;
          }

          .th._brand,
          .td._brand {
            padding-bottom: 0;
          }

          .__hide-shadow {
            margin-right: -1rem;
          }
        }
      }

      @media screen and (max-width: 980px) {
        &.table {
          .tr {
            grid-template-columns: auto 6.625rem;
            grid-template-rows: auto auto 1fr;
            grid-template-areas:
              "topMobile topMobile"
              "brand img"
              "partName img"
              "price img"
              "sellerCounterLocal sellerCounterLocal"
              "sellerCounterAll sellerCounterAll"
          }

          .td._topMobile {
            display: flex;
            justify-content: space-between;
            padding-bottom: 0.625rem;
            font-size: 0.875rem;
          }

          .td._img {
            padding-left: 1rem;
          }

          .td._price {
            font-size: 1.5rem;
          }

          .td._brand {
            padding-bottom: 0.25rem;
            font-size: 1.125rem;
            font-weight: var(--font-weight-bold);
            .valueIsMobile {
              display: inline;
            }
          }

          .td._partName {
            padding-bottom: .625rem;
            font-size: 1rem;
          }

          .td._number,
          .td._applicability {
            display: none;
          }

          .td._sellerCounterLocal {
            margin-top: 1.25rem;
            .buttonSellerCounter {
              width: 100%;
              border: none;
              background-color: var(--btn-bg);
            }
          }

          .td._sellerCounterAll {
            margin-top: 1.25rem;
            text-align: left;

            .valueIsMobile {
              display: inline-block;
              padding-right: 0.25rem;
              font-size: 1rem;
              font-weight: var(--font-weight-medium);
            }

            .buttonSellerCounter {
              display: inline-block;
              padding: 0;
              width: auto;
              height: auto;
              min-height: auto;
              font-size: 1rem;
              color: var(--link-color);
              background-color: transparent;
              border: none;
              box-shadow: none;
            }

          }

          .picture {
            padding-top: 5.625rem;
            background-color: var(--bg-lightest);

            > .svg {
              width: 2.5rem;
              height: auto;
              fill: var(--fill-light);
            }
          }

          .__hide-shadow:after {
            content: none;
          }
        }
      }
    }
  }
</style>
